#ifndef __BridgeToHttp_h__
#define __BridgeToHttp_h__

#include "AtomicPropositions.h"
#include "BThread.h"
#include "IEvent.h"

class BridgeToHttp : public BThread
{
public:
    BridgeToHttp()
    {
        _msgToHttp.add( "MsgToHttp" );
    }

    void entryPoint()
    {
        while ( true )
        {
            waitForRequests();
            handleRequests();
        }
    }

private:
    AtomicPropositions _msgToHttp;

    void waitForRequests()
    {
        clearEventVectors();

        _watched.append( IEvent::DATA_FROM_TCP_TO_HTTP );
        _blocked.append( IEvent::HTTP_DATA_RECEIVED );

        bSync( _requested, _watched, _blocked, "Wait" );
    }

    void handleRequests()
    {
        clearEventVectors();
        _requested.append( Event( IEvent::HTTP_DATA_RECEIVED, lastEvent().payload() ) );
        _blocked.append( IEvent::DATA_FROM_TCP_TO_HTTP );
        bSync( _requested, _watched, _blocked, _msgToHttp, "ToHttp" );
    }
};

#endif // __BridgeToHttp_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
