#ifndef __BridgeToTcp_h__
#define __BridgeToTcp_h__

#include "BThread.h"
#include "IEvent.h"

class BridgeToTcp : public BThread
{
public:
    BridgeToTcp()
    {
        _msgToTcp.add( "MsgToTcp" );
    }

    void entryPoint()
    {
        while ( true )
        {
            waitForRequests();
            handleRequests();
        }
    }

private:
    AtomicPropositions _msgToTcp;

    void waitForRequests()
    {
        clearEventVectors();

        _watched.append( IEvent::DATA_FROM_HTTP_TO_TCP );
        _blocked.append( IEvent::TCP_SEND_PUSH );

        bSync( _requested, _watched, _blocked, "Wait" );
    }

    void handleRequests()
    {
        clearEventVectors();
        _requested.append( Event( IEvent::TCP_SEND_PUSH, lastEvent().payload() ) );
        _blocked.append( IEvent::DATA_FROM_HTTP_TO_TCP );
        bSync( _requested, _watched, _blocked, _msgToTcp, "ToTcp" );
    }
};

#endif // __BridgeToTcp_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
