#ifndef __SequenceNumberPayload_h__
#define __SequenceNumberPayload_h__

#include "ConstSimpleData.h"

struct SequenceNumberPayload
{
public:
    SequenceNumberPayload( unsigned sequenceNumber, unsigned bytesToBeSent ) : _sequenceNumber( sequenceNumber ), _bytesToBeSent( bytesToBeSent )
    {
    }

    SequenceNumberPayload( const ConstSimpleData &payload )
    {
        memcpy( this, payload.data(), sizeof(SequenceNumberPayload) );
    }

    unsigned getSequenceNumber() const
    {
        return _sequenceNumber;
    }

    unsigned getBytesToBeSent() const
    {
        return _bytesToBeSent;
    }

private:
    unsigned _sequenceNumber;
    unsigned _bytesToBeSent;
} __attribute((packed));

#endif // __SequenceNumberPayload_h__

//
// Local Variables:
// compile-command: "make -C .. "
// tags-file-name: "../TAGS"
// c-basic-offset: 4
// End:
//
