#ifndef __HttpDispatcherSimulatorSpanner_h__
#define __HttpDispatcherSimulatorSpanner_h__

#include "HttpDispatcherSimulator.h"
#include "StateGraphSpanner.h"

class HttpDispatcherSimulatorToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new HttpDispatcherSimulator;
    }
};

class HttpDispatcherSimulatorSpanner
{
public:
    void eventsForHttpDispatcherSimulator( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForHttpDispatcherSimulator( stateGraph._events );

        HttpDispatcherSimulatorToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "httpDispatcherSimulator";
    }
};

#endif // __HttpDispatcherSimulatorSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
