#ifndef __HttpDispatcherSpanner_h__
#define __HttpDispatcherSpanner_h__

#include "HttpDispatcher.h"
#include "StateGraphSpanner.h"

class HttpDispatcherToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new HttpDispatcher;
    }
};

class HttpDispatcherSpanner
{
public:
    void eventsForHttpDispatcher( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEventsExcept( IEvent::HTTP_DATA_RECEIVED );

        HeapData serialized;

        char get[] = "dont care GET dont care";
        events.append( Event( IEvent::HTTP_DATA_RECEIVED, ConstSimpleData( get, sizeof(get) ) ) );

        char error[] = "error";
        events.append( Event( IEvent::HTTP_DATA_RECEIVED, ConstSimpleData( error, sizeof(error) ) ) );
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForHttpDispatcher( stateGraph._events );

        HttpDispatcherToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "httpDispatcher";
    }
};

#endif // __HttpDispatcherSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
