#ifndef __HttpFoundHandlerSpanner_h__
#define __HttpFoundHandlerSpanner_h__

#include "HttpFoundHandler.h"
#include "StateGraphSpanner.h"

class HttpFoundHandlerToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new HttpFoundHandler;
    }
};

class HttpFoundHandlerSpanner
{
public:
    void eventsForHttpFoundHandler( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEventsExcept( IEvent::HTTP_GENERATE_FOUND );

        char buffer[] = "hello world";
        events.append( Event( IEvent::HTTP_GENERATE_FOUND, ConstSimpleData( buffer, sizeof(buffer) ) ) );
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForHttpFoundHandler( stateGraph._events );

        HttpFoundHandlerToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "httpFoundHandler";
    }
};

#endif // __HttpFoundHandlerSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
