#ifndef __RawSocketSimulatorSpanner_h__
#define __RawSocketSimulatorSpanner_h__

#include "RawSocketSimulator.h"
#include "StateGraphSpanner.h"

class RawSocketSimulatorToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new RawSocketSimulator;
    }
};

class RawSocketSimulatorSpanner
{
public:
    void eventsForRawSocketSimulator( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForRawSocketSimulator( stateGraph._events );

        RawSocketSimulatorToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "rawSocketSimulator";
    }
};

#endif // __RawSocketSimulatorSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
