#ifndef __TcpPushSenderSpanner_h__
#define __TcpPushSenderSpanner_h__

#include "TcpPushSender.h"
#include "StateGraphSpanner.h"

class TcpPushSenderToken : public StateGraphSpanner::ThreadToken
{
public:
    BThread *freshCopy()
    {
        return new TcpPushSender;
    }
};

class TcpPushSenderSpanner
{
public:
    void eventsForTcpPushSender( Vector<Event> &events )
    {
        events.clear();
        events = IEvent::allEvents();

        events.eraseByValue( IEvent::TCP_ANNOUNCE_TARGET_PORT );
        events.eraseByValue( IEvent::TCP_SEND_PUSH );
        events.eraseByValue( IEvent::SEQUENCE_NUMBER_FOR_PUSH_SENDER );

        TargetPortPayload targetPortPayload( 6000 );
        events.append( Event( IEvent::TCP_ANNOUNCE_TARGET_PORT, ConstSimpleData( &targetPortPayload, sizeof(targetPortPayload) ) ) );

        char buffer[] = "hello world";
        events.append( Event( IEvent::TCP_SEND_PUSH, ConstSimpleData( buffer, sizeof(buffer) ) ) );

        SequenceNumberPayload sequenceNumber( 1, 1 );
        events.append( Event( IEvent::SEQUENCE_NUMBER_FOR_PUSH_SENDER, ConstSimpleData( &sequenceNumber, sizeof(sequenceNumber) ) ) );
    }

    void span( ThreadStateGraph &stateGraph )
    {
        eventsForTcpPushSender( stateGraph._events );

        TcpPushSenderToken token;
        StateGraphSpanner().span( token, stateGraph );

        stateGraph._threadName = "tcpPushSender";
    }
};

#endif // __TcpPushSenderSpanner_h__

//
// Local Variables:
// compile-command: "make -C ../.. "
// tags-file-name: "../../TAGS"
// c-basic-offset: 4
// End:
//
